/************************************************************************/
/*                                                                      */
/*      Print Edit  -  Firefox Extension  -  Options                    */
/*                                                                      */
/*      Javascript for Options dialog                                   */
/*                                                                      */
/*      Copyright (C) 2010  by  David Wilson                            */
/*                                                                      */
/*      Last Edit  -  12 Sep 2010                                       */
/*                                                                      */
/************************************************************************/

var printEditOptions =
{
    prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("printedit."),

    initPrefs: function()
    {
        var menulist,index;
        var colorpicker,color;
        var checkbox,checkstate;

        /* Display Appearance Options */
        
        menulist = document.getElementById("printedit-display-mediaprint");
        try
        {
            menulist.selectedIndex = printEditOptions.prefs.getIntPref("display-mediaprint");
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        
        /* Highlight Box Options */
        
        colorpicker = document.getElementById("printedit-highlight-color");
        try
        {
          color = printEditOptions.prefs.getCharPref("highlight-color");
          colorpicker.color = color;
        }
        catch(e)
        {
          colorpicker.color = "#FF0000";
        }
        
        menulist = document.getElementById("printedit-highlight-width");
        try
        {
            menulist.selectedIndex = printEditOptions.prefs.getIntPref("highlight-width")-1;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        
        /* Select Box Options */
        
        colorpicker = document.getElementById("printedit-select-color");
        try
        {
          color = printEditOptions.prefs.getCharPref("select-color");
          colorpicker.color = color;
        }
        catch(e)
        {
          colorpicker.color = "#FF0000";
        }
        
        menulist = document.getElementById("printedit-select-width");
        try
        {
            menulist.selectedIndex = printEditOptions.prefs.getIntPref("select-width")-1;
        }
        catch(e)
        {
            menulist.selectedIndex = 0;
        }
        
        /* Format Properties Options */
        
        checkbox = document.getElementById("printedit-format-margin");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-margin");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-padding");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-padding");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-border");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-border");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-outline");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-outline");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-verticalalign");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-verticalalign");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-textalign");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-textalign");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-lineheight");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-lineheight");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-format-liststyle");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("format-liststyle");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }

        /* Hide & Undo Options */
        
        checkbox = document.getElementById("printedit-hide-select");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("hide-select");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = false;
        }
        
        checkbox = document.getElementById("printedit-undo-reinstate");
        try
        {
          checkstate = printEditOptions.prefs.getBoolPref("undo-reinstate");
          checkbox.checked = checkstate;
        }
        catch(e)
        {
          checkbox.checked = true;
        }
    },

    savePrefs: function()
    {
        /* Display Appearance Options */
        
        printEditOptions.prefs.setIntPref("display-mediaprint",document.getElementById("printedit-display-mediaprint").value);
        
        /* Highlight Box Options */
        
        printEditOptions.prefs.setCharPref("highlight-color",document.getElementById("printedit-highlight-color").color);
        printEditOptions.prefs.setIntPref("highlight-width",document.getElementById("printedit-highlight-width").value);
        
        /* Select Box Options */
        
        printEditOptions.prefs.setCharPref("select-color",document.getElementById("printedit-select-color").color);
        printEditOptions.prefs.setIntPref("select-width",document.getElementById("printedit-select-width").value);
        
        /* Format Properties Options */
        
        printEditOptions.prefs.setBoolPref("format-margin",document.getElementById("printedit-format-margin").checked);
        printEditOptions.prefs.setBoolPref("format-padding",document.getElementById("printedit-format-padding").checked);
        printEditOptions.prefs.setBoolPref("format-border",document.getElementById("printedit-format-border").checked);
        printEditOptions.prefs.setBoolPref("format-outline",document.getElementById("printedit-format-outline").checked);
        printEditOptions.prefs.setBoolPref("format-verticalalign",document.getElementById("printedit-format-verticalalign").checked);
        printEditOptions.prefs.setBoolPref("format-textalign",document.getElementById("printedit-format-textalign").checked);
        printEditOptions.prefs.setBoolPref("format-lineheight",document.getElementById("printedit-format-lineheight").checked);
        printEditOptions.prefs.setBoolPref("format-liststyle",document.getElementById("printedit-format-liststyle").checked);
        
        /* Hide & Undo Options */
        
        printEditOptions.prefs.setBoolPref("hide-select",document.getElementById("printedit-hide-select").checked);
        printEditOptions.prefs.setBoolPref("undo-reinstate",document.getElementById("printedit-undo-reinstate").checked);
    }
};
